------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------

package body Qt4.Text_Fragments is

   function new_QTextFragment return not null access Qt4_Entities.Cpp_Class;
   pragma Import (C, new_QTextFragment, "__Qt4Ada_new_QTextFragment");

   procedure delete_QTextFragment
    (Cpp_Object : not null access Qt4_Entities.Cpp_Class);
   pragma Import (C, delete_QTextFragment, "__Qt4Ada_delete_QTextFragment");

   procedure assign_QTextFragment
    (S_1 : not null access          Thin.QTextFragment;
     S_2 : not null access constant Thin.QTextFragment);
   pragma Import (C, assign_QTextFragment, "__Qt4Ada_assign_QTextFragment");

   function comparison_QTextFragment_wrapper
    (Left  : not null access Thin.QTextFragment;
     Right : not null access Thin.QTextFragment)
       return bool;
   pragma Import (C,
                  comparison_QTextFragment_wrapper,
                  "__Qt4Ada_comparison_QTextFragment_wrapper");

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> =
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   overriding function "="
    (Left  : Q_Text_Fragment;
     Right : Q_Text_Fragment) return Boolean is
   begin
      return To_Boolean (comparison_QTextFragment_wrapper
                          (Internals.QTextFragment_View (Left),
                           Internals.QTextFragment_View (Right)));
   end "=";

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Copy_Cpp_Object
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   overriding
   function Copy_Cpp_Object (Self : not null access Q_Text_Fragment)
     return not null access Qt4_Entities.Cpp_Class
   is
   begin
      return Thin.copy_QTextFragment (Self.Cpp_Object);
   end Copy_Cpp_Object;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Create
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   function Create return Q_Text_Fragment is
      Result : Q_Text_Fragment;

   begin
      return Result;
   end Create;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Default_Cpp_Object
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   overriding function Default_Cpp_Object
    (Self : not null access Q_Text_Fragment)
       return access Qt4_Entities.Cpp_Class
   is
      pragma Unreferenced (Self);
      --  Параметр необходим для диспетчеризации надклассового вызова.

   begin
      return new_QTextFragment;
   end Default_Cpp_Object;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Delete_Cpp_Object
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   overriding
   procedure Delete_Cpp_Object (Self : not null access Q_Text_Fragment) is
   begin
      delete_QTextFragment (Self.Cpp_Object);
   end Delete_Cpp_Object;

   package body Internals is

      ------------------------------------------------------------------------
      --! <Subprogram>
      --!    <Unit> Cpp_Object
      --!    <ImplementationNotes>
      ------------------------------------------------------------------------
      function QTextFragment_View (Self : Q_Text_Fragment)
        return not null access Thin.QTextFragment is
      begin
         return Qt4_Entities.Cpp_Object (Self);
      end QTextFragment_View;

      ------------------------------------------------------------------------
      --! <Subprogram>
      --!    <Unit> To_Q_Text_Fragment
      --!    <ImplementationNotes>
      ------------------------------------------------------------------------
      function To_Q_Text_Fragment
       (Item : not null access constant Thin.QTextFragment)
          return Q_Text_Fragment is
      begin
         return Result : Q_Text_Fragment do
            assign_QTextFragment (Internals.QTextFragment_View (Result), Item);
         end return;
      end To_Q_Text_Fragment;

   end Internals;

end Qt4.Text_Fragments;
